<?php

$page['header'] = LBL_LOGIN;

if (!source_connect($ldap) || !$ldap['bind']) {
	$page['errors'][] = ERROR_SOURCE_CONNECT;
	return;
}

function login_aselect() {
	global $as, $uuid;
	
	require_once 'grouper-ui-php/federation/agent.inc';

	$result = as_process($as);
	$uuid = $result['attributes']['espeeUid'][0];
	return $result;
}

function login_simpleSAMLphp() {
	global $simple_saml_php, $uuid;
	
	require_once $simple_saml_php . '/lib/_autoload.php';

	$as = new SimpleSAML_Auth_Simple('default-sp');
	$as->requireAuth();
	$attributes = $as->getAttributes();
	$result['attributes'] = $attributes;
	
	$session = SimpleSAML_Session::getInstance();
	$subject = $session->getLogoutState();
	$uuid = $subject["saml:logout:NameID"]["Value"];
	
	return $result;
}

// Check if we're logged in already
if (!array_key_exists('user', $_SESSION)) {
	$result = NULL;
	try {
		$function = 'login_' . $login_type;
		$result = $function();
	} catch (Exception $e) {
		$page['errors'][] = $e->getMessage();
	}
	if ($result !== NULL) {
		if ($uuid !== NULL) {
			$attrs = source_profile($ldap, $uuid);
			if ($attrs !== FALSE) {
				// TODO: sanity check on mandatory/optional attributes
				$_SESSION['user'] = $attrs;
				$page['messages'][] = MESSAGE_AS_OK;
			} else {
				$page['errors'][] = ERROR_SOURCE_PROFILE;      	
				return;
			}
		} else {
			// TODO: warning about incorrect attributes
			$page['errors'][] = ERROR_SOURCE_PROFILE;      	
			return;
		}
	} else {
		$page['errors'][] = ERROR_AS_PROCESS;      	
		return;
	}
}

// Hereafter we're logged in!

// TODO: here??
if (isset($_SESSION['accept_uiid'])) $target = 'process';
else $target = 'teams';

header("location: $target");

?>
